#ifndef SLIDERGROUP_H
#define SLIDERGROUP_H

#include <QGroupBox>
#include <QDoubleSpinBox>
#include <QVBoxLayout>
#include <QSlider>
#include <QDebug>
#include <QEvent>
#include <QMouseEvent>
/*
//slider->installEventFilter(new QSliderAnalyser);
class QSliderAnalyser
        : public QObject
{
    public:
        QSliderAnalyser()
        {
        }

        virtual ~QSliderAnalyser()
        {
        }

    protected:
        bool eventFilter(QObject* object, QEvent* event) override
        {
            if (event->type() == QEvent::MouseButtonPress) {
                qDebug() << event->type() << object->objectName();
            }
            return QObject::eventFilter(object, event);
        }
};*/

class DoubleSpinBoxClickable: public QDoubleSpinBox
{
  Q_OBJECT

public:
  DoubleSpinBoxClickable(QWidget *parent = 0);
  ~DoubleSpinBoxClickable();

signals:
  void enableSlider();

protected:
  void mousePressEvent ( QMouseEvent * event )
  {
    if (event->button() == Qt::LeftButton) {
        qDebug() << "enabling slider";
        emit(enableSlider());
    }
    event->accept();
  }
};

class SliderClickDisable
        : public QSlider
{
    Q_OBJECT

public:
    explicit SliderClickDisable(QWidget *parent = Q_NULLPTR);
    ~SliderClickDisable();

protected:
  void mousePressEvent ( QMouseEvent * event )
  {
    if (event->button() == Qt::RightButton)
    {
        if (this->isEnabled()) {
            qDebug() << "disabling slider";
            this->setDisabled(true);
        }
        event->accept();
    }
    QSlider::mousePressEvent(event);
  }
};

class SliderGroup : public QWidget
{
    Q_OBJECT

public:
    SliderGroup(QString name,
                int min,
                int max,
                int decimals,
                QWidget *parent = nullptr);

signals:
    void valueChanged(int value);

public slots:
    void setValue(float value);
    void sliderValueChanged(int value);

private:
    SliderClickDisable slider;
    DoubleSpinBoxClickable valueBox;

private slots:
    void enableSlider() { slider.setEnabled(true); }

};

#endif
